// Code generated by Wire. DO NOT EDIT.

//go:generate go run github.com/google/wire/cmd/wire
//go:build !wireinject
// +build !wireinject

package infrastructure

import (
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/application/services"
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/infrastructure/dependencies"
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/infrastructure/providers/http_server"
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/infrastructure/providers/mongo"
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/infrastructure/providers/router"
	"gitlab.com/ulan.alsiyeu/user_iin_service/internal/infrastructure/repositories"
)

// Injectors from wire.go:

func BuildApplication() (*Application, error) {
	client, err := mongo.Initialize()
	if err != nil {
		return nil, err
	}
	users := repositories.InitializeUsersRepository(client)
	servicesUsers := services.InitializeUsersService(users)
	container := &dependencies.Container{
		UsersRepository: users,
		UsersService:    servicesUsers,
	}
	engine := router.Initialize(container)
	httpServerConfig := http_server.InitializeHTTPServerConfig(engine)
	server := http_server.InitializeHTTPServer(httpServerConfig)
	application := &Application{
		HttpServer: server,
		container:  container,
	}
	return application, nil
}
